--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_hub.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_hub.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,128 @@
+/* name: mausb_hub.h 
+ * description: header file for mausb hub 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_HUB_H 
+#define __MAUSB_HUB_H 
+ 
+#include <linux/init.h> 
+#include <linux/module.h> 
+#include <linux/usb.h> 
+#include <linux/usb/hcd.h> 
+#include <linux/platform_device.h> 
+#include <linux/usb/ch11.h> 
+ 
+/* root hub Parameters */ 
+#define MAUSB_ROOTHUB_CHAR (HUB_CHAR_LPSM | HUB_CHAR_INDV_PORT_OCPM) 
+#define MAUSB_ROOTHUB_NUM_PORTS 1 
+#define MAUSB_ROOTHUB_PWR_ON_2_PWR_GOOD 0 
+#define MAUSB_ROOTHUB_CONTR_CURRENT 0 
+#define MAUSB_ROOTHUB_HDR_DEC_LAT 0 /* < 0 uS */ 
+#define MAUSB_ROOTHUB_DELAY 0 /* 0 nS */ 
+#define MAUSB_ALL_DEV_REMOVABLE 0x0000 /* All devices are removable */ 
+ 
+/* per USB3 spec, section 9.4.3 */ 
+#define MAUSB_REQ_GET_DES (0x8000 | USB_REQ_GET_DESCRIPTOR) 
+ 
+/* link state selectors for set_port_feature request to root hub */ 
+#define SS_DISABLED 4 
+#define RX_DETECT 5 
+ 
+/* mask used to clear port link state bits (bits 5-8) in wPortStatus */ 
+#define LINK_STATE_MASK 0xFE1F 
+ 
+/* forward declarations */ 
+struct mausb_root_hub; 
+struct mausb_hcd; 
+ 
+/* root hub states */ 
+enum mausb_rh_state { 
+ MAUSB_RH_RESETTING, 
+ MAUSB_RH_SUSPEND, 
+ MAUSB_RH_RUNNING 
+}; 
+ 
+/** 
+ * Contains all the structures required to emulate a root hub. One instance 
+ * exists per root hub. 
+ */ 
+struct __attribute__((__packed__)) mausb_root_hub { 
+ 
+ /* hub parameters */ 
+ struct usb_hub_descriptor descriptor; 
+ struct usb_hub_status status; 
+ 
+ /* port parameters*/ 
+ struct usb_port_status port_status[MAUSB_ROOTHUB_NUM_PORTS]; 
+ 
+ /* root hub state */ 
+ enum mausb_rh_state rh_state; 
+ 
+}; 
+ 
+/* function declarations */ 
+bool mausb_is_ss_hcd(struct usb_hcd *hcd); 
+int mausb_hub_status_data(struct usb_hcd *hcd, char *buf); 
+int mausb_set_hub_descriptor(struct usb_hub_descriptor *hub_des); 
+int mausb_set_ss_hub_descriptor(struct usb_hub_descriptor *hub_des); 
+int mausb_hub_control(struct usb_hcd *hcd, u16 typeReq, u16 wValue, 
+ u16 wIndex, char *buf, u16 wLength); 
+int mausb_init_port_status(struct mausb_root_hub *mausb_rh); 
+int mausb_init_ss_port_status(struct mausb_root_hub *mausb_rh); 
+int mausb_connect(struct mausb_hcd *hcd, int portnum, int do_connect); 
+struct mausb_root_hub *usb_hcd_to_roothub(struct usb_hcd *hcd); 
+ 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_ioctl.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_ioctl.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_ioctl.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_ioctl.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,256 @@
+/* Name: mausb_ioctl.c 
+ * Description: ioctl functions for MA USB media specific driver 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/ioctl.h> 
+#include <linux/kernel.h> 
+#include <linux/fs.h> 
+#include <linux/kernel.h> 
+#include <linux/fs.h> 
+#include <linux/usb/gadget.h> 
+#include <linux/init.h> 
+#include <linux/module.h> 
+#include <asm/uaccess.h> 
+#include "mausb_hcd.h" 
+#include "mausb_udc.h" 
+#include "mausb_ioctl.h" 
+ 
+/* #define MAUSB_PRINT_IOCTL_MAGIC */ 
+#define DEBUG 
+ 
+static int ma_open; 
+ 
+/** 
+ * This function is used to open the device file in order to read/write 
+ * from/to it. 
+ * 
+ * @inode: Struct with various information that is passed in when this 
+ * function is called. We don't need to use it for our purposes. 
+ * @file: The file to be opened. 
+ */ 
+static int mausb_open(struct inode *inode, struct file *file) 
+{ 
+ if (ma_open) 
+ return -EBUSY; 
+ ma_open++; 
+ try_module_get(THIS_MODULE); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * This function is used to close the device file. 
+ * 
+ * @inode: Struct with various information that is passed in when this 
+ * function is called. We don't need to use it for our purposes. 
+ * @file: The file to be closed. 
+ */ 
+static int mausb_release(struct inode *inode, struct file *file) 
+{ 
+ ma_open--; 
+ module_put(THIS_MODULE); 
+ 
+ return 0; 
+} 
+ 
+ 
+/** 
+ * This function is used to execute ioctl commands, determined by ioctl_func. 
+ * 
+ * @file: The device file. We don't use it directly, but it's passed in. 
+ * @ioctl_func: This value determines which ioctl function will be used. 
+ * @ioctl_buffer: This buffer is used to transfer data to/from the device. 
+ */ 
+long mausb_ioctl(struct file *file, unsigned int ioctl_func, 
+ unsigned long ioctl_buffer) 
+{ 
+ char message[BUFFER]; 
+ int ret, value; 
+ unsigned long int long_value; 
+ char __user *msg = (char *)ioctl_buffer; 
+ char *response; 
+ 
+ switch (ioctl_func) { 
+ case IOCTL_GET_VRSN: 
+ ret = copy_to_user(msg, DRIVER_VERSION, strlen(DRIVER_VERSION)); 
+ break; 
+ case IOCTL_GET_NAME: 
+ ret = copy_to_user(msg, MAUSB_NAME, strlen(MAUSB_NAME)); 
+ break; 
+ case IOCTL_GADGET_C: 
+ ret = gadget_connection(1); 
+ if (ret >= 0) 
+ response = MAUSB_GADGET_C_SUCCESS; 
+ else 
+ response = MAUSB_GADGET_C_FAIL; 
+ 
+ ret = copy_to_user(msg, response, strlen(response)); 
+ break; 
+ case IOCTL_GADGET_D: 
+ ret = gadget_connection(0); 
+ if (ret >= 0) 
+ response = MAUSB_GADGET_D_SUCCESS; 
+ else 
+ response = MAUSB_GADGET_D_FAIL; 
+ 
+ ret = copy_to_user(msg, response, strlen(response)); 
+ break; 
+ case IOCTL_SET_PORT: 
+ ret = strncpy_from_user(message, msg, BUFFER); 
+ if (ret < 0) 
+ break; 
+ ret = kstrtoint(msg, 0, &value); 
+ if (ret != 0) 
+ break; 
+ 
+ ret = set_port_no(value); 
+ sprintf(message, "PORT NUMBER:%d, Returned %i\n", value, 
+ ret); 
+ ret = copy_to_user(msg, message, strlen(message)); 
+ break; 
+ case IOCTL_SET_IP: 
+ ret = strncpy_from_user(message, msg, BUFFER); 
+ if (ret < 0) 
+ break; 
+ ret = kstrtoul(message, 0, &long_value); 
+ if (ret != 0) 
+ break; 
+ 
+ ret = set_ip_addr(long_value); 
+ sprintf(message, "IP ADDRESS:%lx, returned %i\n", 
+ long_value, ret); 
+ ret = copy_to_user(msg, message, strlen(message)); 
+ break; 
+ case IOCTL_SET_MAC: 
+ { 
+ u8 mac[6]; 
+ int i; 
+ ret = copy_from_user(mac, msg, 6); 
+ if (ret) { 
+ pr_err("copy_from_user failed\n"); 
+ break; 
+ } 
+ for (i = 0; i < ETH_ALEN; i++) 
+ pr_info("mac[%d]=0x%x\n", i, mac[i]); 
+ ret = set_mac_addr(mac); 
+ if (ret) 
+ pr_err("unable to set MAC addr\n"); 
+ 
+ break; 
+ } 
+ } 
+ 
+ /* failure */ 
+ if (ret < 0) 
+ return ret; 
+ 
+ /* success */ 
+ return 0; 
+} 
+ 
+/** 
+ * This struct creates links with our implementations of various entry point 
+ * functions. 
+ */ 
+const struct file_operations fops = { 
+ .open = mausb_open, 
+ .release = mausb_release, 
+ .unlocked_ioctl = mausb_ioctl 
+}; 
+ 
+/** 
+ * Registers a character device using our device file. This function is called 
+ * in the mausb_hcd_init function. 
+ */ 
+int reg_chrdev() 
+{ 
+ int ret; 
+ 
+#ifdef MAUSB_PRINT_IOCTL_MAGIC 
+ 
+ printk(KERN_DEBUG "Printing IOCTL magic numbers:\n"); 
+ printk(KERN_DEBUG "IOCTL_SET_MSG = %u\n", IOCTL_SET_MSG); 
+ printk(KERN_DEBUG "IOCTL_GET_MSG = %u\n", IOCTL_GET_MSG); 
+ printk(KERN_DEBUG "IOCTL_GET_VRSN = %u\n", IOCTL_GET_VRSN); 
+ printk(KERN_DEBUG "IOCTL_GET_NAME = %u\n", IOCTL_GET_NAME); 
+ printk(KERN_DEBUG "IOCTL_GADGET_C = %u\n", IOCTL_GADGET_C); 
+ printk(KERN_DEBUG "IOCTL_GADGET_D = %u\n", IOCTL_GADGET_D); 
+ printk(KERN_DEBUG "IOCTL_MED_DELAY = %u\n", IOCTL_MED_DELAY); 
+ printk(KERN_DEBUG "IOCTL_SET_IP = %u\n", IOCTL_SET_IP); 
+ printk(KERN_DEBUG "IOCTL_SET_PORT = %u\n", IOCTL_SET_PORT); 
+ printk(KERN_DEBUG "IOCTL_SET_IP_DECIMAL = %u\n", IOCTL_SET_IP_DECIMAL); 
+ printk(KERN_DEBUG "IOCTL_SET_MAC = %u\n", IOCTL_SET_MAC); 
+ 
+#endif 
+ 
+ ret = register_chrdev(MAJOR_NUM, MAUSB_NAME, &fops); 
+ 
+ if (ret < 0) 
+ printk(KERN_ALERT "Registering mausb failed with %d\n", ret); 
+ else 
+ printk(KERN_INFO "%s registeration complete. Major device" 
+ " number %d.\n", MAUSB_NAME, MAJOR_NUM); 
+ 
+ return ret; 
+} 
+ 
+/** 
+ * Unregisters the character device when the hcd is unregistered. As hinted, 
+ * this function is called in the mausb_hcd_exit function. 
+ */ 
+void unreg_chrdev() 
+{ 
+ unregister_chrdev(MAJOR_NUM, MAUSB_NAME); 
+} 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_ioctl.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_ioctl.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_ioctl.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_ioctl.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,101 @@
+/* Name: mausb_ioctl.h 
+ * Description: header file for MA USB ioctl functions 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef MAUSB_IOCTL_H 
+#define MAUSB_IOCTL_H 
+ 
+#define BUFFER 80 
+#define DRIVER_VERSION "Alpha 0.0.25" 
+#define MAJOR_NUM 100 
+ 
+/* These define the ioctl functions that can be used. */ 
+#define IOCTL_GET_VRSN _IOR(MAJOR_NUM, 0, char *) 
+#define IOCTL_GET_NAME _IOR(MAJOR_NUM, 1, char *) 
+#define IOCTL_GADGET_C _IOR(MAJOR_NUM, 2, char *) 
+#define IOCTL_GADGET_D _IOR(MAJOR_NUM, 3, char *) 
+#define IOCTL_SET_IP _IOR(MAJOR_NUM, 4, char *) 
+#define IOCTL_SET_PORT _IOR(MAJOR_NUM, 5, char *) 
+#define IOCTL_SET_MAC _IOR(MAJOR_NUM, 6, char *) 
+ 
+/* This is the location where the device file will be created. It is used to 
+ * read/write to in order to communicate to and from the device. */ 
+#define DEVICE_FILE_NAME "/dev/mausb" 
+ 
+/* MAC address length */ 
+#define ETH_ALEN 6 
+ 
+/* Responses to IOCTL calls */ 
+#define MAUSB_GADGET_C_SUCCESS "gadget connect process complete" 
+#define MAUSB_GADGET_C_FAIL "gadget connect process failed" 
+#define MAUSB_GADGET_D_SUCCESS "gadget disconnect process complete" 
+#define MAUSB_GADGET_D_FAIL "gadget disconnect process failed" 
+ 
+/* forward declarations */ 
+struct mausb_udc; 
+struct mausb_hcd; 
+ 
+/* Functions for register/unregistering the character device */ 
+int reg_chrdev(void); 
+void unreg_chrdev(void); 
+ 
+/* Medium-defined functions */ 
+int set_medium_delay(int delay); 
+int set_ip_addr(unsigned long in_addr); 
+int set_port_no(int port_no); 
+int set_mac_addr(unsigned char mac_addr[ETH_ALEN]); 
+int gadget_connection(int on); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_mem.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_mem.c
